/*
 * Created by IntelliJ IDEA.
 * User: kcpeppe
 * Date: Jun 15, 2002
 * Time: 7:05:36 PM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package com.sams.ant.chatroom;

import com.sams.ant.channel.Content;
import com.sams.ant.channel.WriteChannel;
import com.sams.ant.channel.ReadChannel;
import com.sams.ant.channel.ChannelListener;
import com.sams.ant.channel.ChannelException;

import java.util.List;
import java.util.ArrayList;

public class TopicMessage implements Content, ChatRoomMessage {

    private List topicChoices;
    private String id;

    public TopicMessage(String id) {
        this.id = id;
        this.topicChoices = new ArrayList();
    }

    public String getId() {
        return this.id;
    }

    public List getTopicChoices() {
        return this.topicChoices;
    }

    public void addTopic(String topic) {
        this.getTopicChoices().add(topic);
    }
}
