/**
  *
  * @author Kirk Pepperdine
  *
  */

package com.sams.ant.taskdef;

import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.HashSet;

public class ClassPathElement extends PathElement {

    public final static String EXTENSION = ".class";

    HashSet classFiles;

    public ClassPathElement(String element) {
        super(element,EXTENSION);
    }

    public HashSet getClassFiles() {
        HashSet set = super.getFileSet();
        Iterator i = set.iterator();
        String path;
        while (i.hasNext()) {
            path = (String)i.next();
            if (isInnerClass(path))
                set.remove(path);
        }

        return set;
    }

    private boolean isInnerClass(String name) {
        return name.indexOf('$') != -1;
    }

}
