package com.jpt.testcomp;

public class TestComponent {

    public TestComponent() {}

    public void runJava2Style(String implementation, String arg) throws ClassNotFoundException, InstantiationException, IllegalAccessException {
        Class clazz = Class.forName( implementation, true, Thread.currentThread().getContextClassLoader());
        TestComponentInterface tci = (TestComponentInterface)clazz.newInstance();
        tci.run(arg);
    }

    public void runJDK11Style(String implementation, String arg) throws ClassNotFoundException, InstantiationException, IllegalAccessException {
        Class clazz = Class.forName( implementation);
        TestComponentInterface tci = (TestComponentInterface)clazz.newInstance();
        tci.run(arg);
    }
}
