/*
 * Created by IntelliJ IDEA.
 * User: kcpeppe
 * Date: Jun 16, 2002
 * Time: 2:39:28 PM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package com.sams.ant.chatroom.unittest;

import com.sams.ant.chatroom.ChatClient;
import com.sams.ant.chatroom.ChatRoom;
import com.sams.ant.chatroom.ChatRoomListener;
import com.sams.ant.chatroom.ChatRoomException;
import com.sams.ant.channel.ChannelException;

import java.util.List;

public class TopicClientTestCase2 implements ChatRoomListener {

    private String title;
    private ChatClient client;
    private List topics;
    private ChatRoom room;

    public TopicClientTestCase2(String title) {
        this.title = title;
    }

    public void setUp() {
        client = new ChatClient("user2","chat");
    }

    private void testEquals(String realized, String expected) {
        System.out.println(realized + " : " +expected);
        if ( ! (expected.equals(realized))) {
            System.out.println("Test failed");
            System.exit(0);
        }
    }
    public void tearDown() {
    }

    public void testChatRoom() {
        try {
            this.resolveTopicList();
            room = client.enter(this,(String)this.topics.get(0));
            System.out.println("Entered room " + this.topics.get(0));
            room.send("Hello World.");
            try {
                Thread.sleep(60000);
            } catch (InterruptedException e) {
            }
        } catch (ChatRoomException e) {
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
    }

    public void resolveTopicList() {
        this.topics = this.client.resolveTopicList();
    }

    public void recieve(String id, String message) {
        System.out.println( id + " : " + message);
        try {
            room.send("Hello");
        } catch (ChatRoomException e) {
        }
        this.room.leave();
        System.exit(0);
    }

    public static void main(String[] args) {
        TopicClientTestCase2 tc = new TopicClientTestCase2("ChatRoom 1");
        tc.setUp();
        tc.testChatRoom();
        tc.tearDown();
    }

}
