/*
 * Created by IntelliJ IDEA.
 * User: kcpeppe
 * Date: Jun 15, 2002
 * Time: 8:10:47 PM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package com.sams.ant.chatroom;

import com.sams.ant.channel.WriteChannel;
import com.sams.ant.channel.ChannelException;

import java.util.ResourceBundle;
import java.util.MissingResourceException;

public class AdminServer implements ChatResources {

    public AdminServer() {}

    public void shutdownTopicServer() {
        try {
            WriteChannel source = new WriteChannel();
            ResourceBundle bundle = ResourceBundle.getBundle("com.sams.ant.chatroom.chatserver");
            String host = bundle.getString(CHATROOM_HOST);
            String port = bundle.getString(CHATROOM_PORT);
            String user = bundle.getString(CHAT_SERVER_USER);
            String password = bundle.getString(CHAT_SERVER_PASSWORD);
            String topic = bundle.getString(CHATROOM_TOPIC_SERVER);
            source.open( host, port, user, password, topic);
            AdminMessage message = new AdminMessage("AdminServer");
            System.out.println("Shutdown Server @" + host + ":" + port);
            source.send(message);
            source.close();
            System.out.println("Shutdown complete");
        } catch (Throwable throwable) {
            System.out.println(throwable.getMessage());
            throwable.printStackTrace();
        }
    }

    public static void main(String[] args) {
        AdminServer admin = new AdminServer();
        admin.shutdownTopicServer();
    }
}
